UNIT EDIT_UN;

(*
         Ŀ
              This is a part of the original source text for the    
                program DisCo, version 1.4 - 18 April 1997          
                                                                    
                                                  
                              EDIT_UN.PAS 1.1                       
                                                  
                                                                    
           If you modify this unit, please                          
                                                                    
              (1) Make sure that you have a copy of the original    
                  file.                                             
                                                                    
              (2) Delete this comment (25 lines).                   
                                                                    
           Original size of file:  54575 bytes.                     
         
             Copyright       Bent Nielsen
                             Institute of Mathematical Statistics
                             University of Copenhagen
                             Universitetsparken 5
                             2100 Copenhagen O
                             DK - Denmark
*)

{ ----------  This unit controls the editor -------------- }

{-------- InterFace -------------------------------------- }

INTERFACE

CONST
      DimQueue           = 30; { Max 40
                                                                       *******
                                  This constant may be changed         **OBS**
                                  if you want a larger queue.
                                  Note that the program will break
                                  down if this dimension exceeds 40.

                                  This reaction can be avoided by
                                  changing the procedures
                                  PROCEDURE GlobalInitializeVariables
                                  PROCEDURE WriteQueue }

TYPE
      QueueType          = Record
                             Dim  : Byte;
                             Data : Array[1..DimQueue] of String;
                           End;

VAR
      Queue, ResultQueue : QueueType;
      ExitProgram  : Boolean;

PROCEDURE PageStart;
PROCEDURE Page0;
PROCEDURE PageQueueEmpty;

FUNCTION PickFirstElementOfQueue(Var Queue:QueueType): String;
PROCEDURE AddElementToQueue(Var Queue:QueueType; s:String);
PROCEDURE EgaVgaDriverProc;

{-------- Implementation --------------------------------- }

IMPLEMENTATION

USES     Crt,DOS,Graph,{BGIDriv2,}Matrix;

CONST   VersionAndDate    = 'Version 1.4 - 18 April 1997';
        DimLinePiece      = 7;  { Max 6                                 *******
                                                                        **OBS**
                                   This constant may be changed         *******
                                   if you want deterministic terms
                                   constructed by more than 3 line
                                   pieces.  Note that according to
                                   the paper Johansen & Nielsen
                                   (1993, preliminary) this will
                                   not give a nice statistical model.   }
        Nspace            = 14;  { This constant tells how many free bytes is
                                   needed for the ERASEME file by each
                                   repetition }
        LetterSet         = ['a'..'z','A'..'Z'];
        DigitSet          = ['0'..'9'];
        SKIP              = #173;       { Alt X implies Halt }
        NULL              = #0;
        ESCAPE            = #27;
        BSKEY             = #8;
        ENTER             = #13;
        HOMEKEY           = #199;
        UPKEY             = #200;
        PGUPKEY           = #201;
        LEFTKEY           = #203;
        RIGHTKEY          = #205;
        ENDKEY            = #207;
        DOWNKEY           = #208;
        PGDNKEY           = #209;
        INSKEY            = #210;
        DELKEY            = #211;
        HELP              = #63;         {?}
        CursorMoveSet     = [BSKey,HomeKey,UpKey,PgUpKey,LeftKey,
                              RightKey,EndKey,DownKey,PgDnKey,InsKey,DelKey];
        HelpSet           = ['0',UPKEY,DOWNKEY,PGUPKEY,PGDNKEY];

(*  If a ColourScreen is used the following option must be used *)

        ColourScreen       = TRUE;
        GREENback          = GREEN;
        GREENtext          = GREEN;
        REDline            = RED;

(* ColourScreen End *)

(* If a Mono Chrome Screen is used the following options must be used *)
(*
        ColourScreen       = FALSE;
        BLUE               = BLACK;
        GREENback          = BLACK;
        RED                = BLACK;
        REDline            = WHITE;
        GREENtext          = WHITE;
        LIGHTBLUE          = WHITE;
  *)
(* Mono Crome Screen End *)

FixedRandomStartInit=True;                           RanRange='F or R';
NInit=10000;      Nmin=0;          Nmax=1000000;     NRange='0 -> 1,000,000';
TInit=400;        TMin=2;         TMax=800;          TRange='2 -> 800';
DimNonStatInit=1; DimNonStatmin=1; DimNonStatmax=17; DimNonStatRange='1 -> 17';
DimUnResTrendInit=0;               DimUnResTrendMax=3;
                  DimUnResTrendMin=0;               DimUnResTrendRange='0 -> Min(p-r,3) ';
DimTrendStatInit=0;                DimTrendStatMax=3;
                 DimTrendStatMin=0;                 DimTrendStatRange='0 -> 3';
DimResInit=0;     DimResMin=0;     DimResMax=3;      DimResRange='0 -> 3';
DimConditionalVarInit=0;      DimConditionalVarMin=0;
                                        DimConditionalVarRange='0 -> 17-(p-r)';

TYPE
      WindowAttr = Record
                        min,max   : word;
                        col       : Byte;
                        xPos,yPos : Byte;
                   End;

      CorrectionType = Array[1..DimLinePiece] Of Record
                                        y1,x2,y2 : LongInt;
                                      End;

Var   Choice :Char;
      OK,ExitUnit  :Boolean;

      s,PageHead, FileName : String;

      FixedRandomStart:Boolean;
      Reg1, Reg2, Reg3, Res1, Res2, Res3 : CorrectionType;
      N ,T,
      DimNonStat, DimTrendStat, DimUnResTrend, DimConditionalVar: LongInt;

      ErrorCode:Byte;


PROCEDURE EgaVgaDriverProc; external;
  { This procedure has been taken from :

    Copyright (c) 1985, 1990 by Borland International, Inc.

    Sample unit to accompany BGILINK.PAS. This unit links the BGI
    graphics driver into a single TPU file. This makes it easy to
    link the driver files directly into an .EXE file. See
    BGILINK.PAS for more information.
  }
  {$L EGAVGA.OBJ }

PROCEDURE InitWrite(x,y,Foregroundcolor,backgroundcolor:byte);
BEGIN { PROCEDURE InitWrite }
  GoToXY(x,y);
  TextBackGround(backgroundcolor);
  TextColor(foregroundcolor);
END;  { PROCEDURE InitWrite }

PROCEDURE SaveWindow(var w:windowattr);
BEGIN { PROCEDURE SaveWindow }
  w.max:= WindMax;
  w.min:= WindMin;
  w.Xpos:= WhereX;
  w.yPos:= WhereY;
  W.col:= TextAttr;
END;  { PROCEDURE SaveWindow }

PROCEDURE RestoreWindow(var w:windowattr);
BEGIN { PROCEDURE RestoreWindow }
  With w Do Begin
    WindMax:=  max;
    WindMin:=  min;
    TextAttr:= col;
    GoToXY(xPos,yPos);
  End;
END;  { PROCEDURE RestoreWindow }

PROCEDURE SetWindow(x,y,width,height,backgroundcolor :Byte);
BEGIN { PROCEDURE SetWindow }
  Window(x,y,x+width-1,y+height-1);
  TextBackground(backgroundcolor);
END;  { PROCEDURE SetWindow }

PROCEDURE ResetWindow(x,y,width,height:byte);
BEGIN { PROCEDURE ResetWindow }
  SetWindow(x,y,width,height,BLACK); ClrScr;
  SetWindow(1,1,80,25,BLACK);
END;  { PROCEDURE ResetWindow }

PROCEDURE Error(ErrorCode:Byte);
Var      w: WindowAttr;
         ch: char;
         s : String;
BEGIN { PROCEDURE Error }
  SaveWindow(w);
  SetWindow(1,2,80,1,BLACK);ClrScr;

  If ErrorCode = 0
  Then OK:= True
  Else Begin
         InitWrite(1,1,WHITE,RED);
         OK:= False;
         Case ErrorCode Of
            1: s:='ERROR 1: These characters must be letters !';
            2: s:='ERROR 2: These characters must be digits !';
            3: s:='ERROR 3: These characters must be letters or digits !';
            4: s:='ERROR 4: This character must be a F or a R !';
            5: s:='ERROR 4: This character must be a C, a L or a M !';
            6: s:='ERROR 6: Out of range !';
            7: s:='ERROR 7: T <= # NonStat + # Res Drift.  Input a new T !';
            8: s:='ERROR 8: p-r < # UnRes Drift.  Input a new p-r !';
            9: s:='WARNING 9: Zero Function !  Dim := Dim-1  -  unless You press "Esc" !';
           10: s:='WARNING 10: N must be <= 10,000 or a multiplum of 10,000 to get quantiles !';
           11: s:='ERROR 11: N is to large. Not sufficient free bytes at the current drive !';
           12: s:='ERROR 12: File does not exist !';
           13: s:='ERROR 13: The file does not have the proper format !';
           14: Begin
                 Str(DimQueue,s);
                 s:=Concat('ERROR 14: Max length of the queue is ',s,' !');
               End;
           15: s:='ERROR 15: The simulation queue is empty !';
           16: s:='ERROR 16: m-r + # Conditional Var > 17.  Input new values of these !';
           17: s:='ERROR 17: The screen is not VGA.  Thus no graphics !';
           18: s:='ERROR 18: The drift terms are linear dependent !';
           19: s:='ERROR 19: The file does not have the proper format !';
           20: s:='FATAL ERROR 20: Source Code has been changed in non proper way !';
           21: s:='ERROR 21: The Help File "DisCo.HLP" does not exist !';
           22: s:='ERROR 22: m-r > 17.  Input new value of m-r !';
         End;
         Case ErrorCode Of
            1,2,3,4,5,6,7,8,9,11,16,17,18 :
               Write(' ',s,' ');
           10:
               Begin Write(' ',s,' '); OK:= True; End;
           12,13,14,15,19,21 :
               Begin
                 Write(' ',s,'  Press Any Key ! ');
                 Ch:= ReadKey;
                 ReStoreWindow(w);
                 Error(0);
               End;
           20:
               Begin
                 Write(' ',s,' ');
                 Ch:= ReadKey;
                 HALT;
               End;
         End;
       End;
  RestoreWindow(w);
End;

FUNCTION MinLongInt(x,y:LongInt):LongInt;
BEGIN { MinLongInt(x,y:LongInt) }
  If x>y Then MinLongInt:=y
         Else MinLongInt:=x;
END;  { MinLongInt(x,y:LongInt) }

PROCEDURE InitializeCorrection(var Cor:CorrectionType);
Var      Row:Byte;
BEGIN { PROCEDURE InitializeCorrection }
  For Row:= 1 To DimLinePiece Do
    With Cor[Row] Do
      Begin y1:=0; x2:=0; y2:=0 End;
END;  { PROCEDURE InitializeCorrection }

PROCEDURE GlobalInitializeVariables;
Var      Row:Byte;
BEGIN { PROCEDURE GlobalInitializeVariables }
  If DimLinePiece>7 Then Error(20);
  If DimQueue>40 Then Error(20);
  Queue.Dim:=0;
  ResultQueue.Dim:=0;
  FileName:= 'SIM';
  FixedRandomStart:=FixedRandomStartInit;
  N:= NInit;
  T:= TInit;
  DimNonStat:= DimNonStatInit;
  DimTrendStat:= DimTrendStatInit;
  DimUnResTrend:= DimUnResTrendInit;
  DimConditionalVar:= DimConditionalVarInit;
  InitializeCorrection(Reg1);
  InitializeCorrection(Reg2);
  InitializeCorrection(Reg3);
  InitializeCorrection(Res1);
  InitializeCorrection(Res2);
  InitializeCorrection(Res3);
END;  { PROCEDURE GlobalInitializeVariables }

PROCEDURE SetPageBegin(PageHead:String);
BEGIN { PROCEDURE SetPageBegin }
  SetWindow(1,1,80,25,BLACK);ClrScr;
  InitWrite(1,1,White,BLUE);
  Write(' ',PageHead,' ');
  SetWindow(1,1,80,25,BLACK);
END;  { PROCEDURE SetPageBegin }

PROCEDURE WriteCorrectionNumber(No:LongInt);
BEGIN { PROCEDURE WriteCorrectionNumber }
  Case No Of
    0 : Write('???     ');
    1 : Write('Constant');
    2 : Write('Linear  ');
    3 : Write('Mixed   ');
  End;
END;  { PROCEDURE WriteCorrectionNumber }

PROCEDURE WriteCorrection(Var Cor:CorrectionType; var No:LongInt);
BEGIN { PROCEDURE WriteCorrection }
  No:=3;
  If (Cor[1].X2=0)   And (Cor[1].y1=0) And (Cor[1].y2=0)  Then No:=0;
  If (Cor[1].x2=100) And (Cor[1].y2>0) And (Cor[1].y1=Cor[1].y2) Then No:=1;
  If (Cor[1].x2=100) And (Cor[1].y1=0) And (Cor[1].y2=100) Then No:=2;
  WriteCorrectionNumber(No);
END;  { PROCEDURE WriteCorrection }

FUNCTION GetKey: Char;
  { Reads the next keyboard character }
VAR      Ch : Char;
BEGIN { FUNCTION GetKey }
  Ch:= NULL;
  Ch:= ReadKey;
  Repeat
    If Ch = NULL Then
      Begin
        Ch:= ReadKey;
        If Ord(Ch) > 127 Then
          Ch:= NULL
        Else
          Ch:= Chr(Ord(Ch) + 128);
      End;
  Until Ch <> NULL;
  If Ch= SKIP Then HALT;
  GetKey:= Ch;
END;  { FUNCTION GetKey }

PROCEDURE ReadString(Space,CharType:Byte; var s:String);
VAR      Ch:Char;
         x,WrittenTo:byte;
         n:longint;
         OneMore:Boolean;
{ CharType is one of the following:
  2 : digits
  3 : digits and characters
      used to input file names
  4 : 0, r, R, 1, f, F
      used to input whether the random generator should be started by a
      fixed value or a random value.
  5 : 0, 1, c, C, 2, l, L, 3, m, M
      used to input the type of the trend: constant, linear or mixed.
  6 : -1.00 -> 1.00
      used to input the structure of the trend.
      From this procedure the numbers
           -1.00  to -0.01    are registered as -200 to -101
            0.00  to  1.00    are registered as  100 to  200
}
PROCEDURE WriteString;
VAR      Col: Byte;
{ This procedure write the string 's' in the current window,
  by taking the CharType into account.  For CharTypes see above.
}
BEGIN { PROCEDURE WriteString }
  GoToXY(1,1);
  For Col:= 1 To Space Do Write(' ');
  GoToXY(1,1);
  Case CharType of
    2,3:   Write(s);
    4 :    Case s[1] Of  '0': Write('Randomized');
                         '1': Write('Fixed     ');
           End;
    5 :    Case s[1] Of  '0': WriteCorrectionNumber(0);
                         '1': WriteCorrectionNumber(1);
                         '2': WriteCorrectionNumber(2);
                         '3': WriteCorrectionNumber(3);
           End;
    6:     Begin
             Write(s[1]);
             Write(Char(Ord(s[2])-1));
             Write('.');
             For Col:=3 To WrittenTo Do
               Write(s[Col]);
           End;
  End;
END;  { PROCEDURE WriteString }

FUNCTION ItIsNotAnActionKey(Ch:Char;var x:Byte; var s:String):Boolean;
VAR      Eye: Char; Col:Byte;
BEGIN {PROCEDURE ItIsNotAnActionKey}
  If Ch in CursorMoveSet
  Then Begin
      ItIsNotAnActionKey:=False;
      Case Ch Of
        BSKEY     : If x>1
                    Then Begin
                      x:=x-1;
                      Delete(s,x,1);
                      WriteString;
                      WrittenTo:= WrittenTo -1;
                    End;
        HOMEKEY   : x:=1;
        LEFTKEY   : If x>1 Then x:=x-1;
        RIGHTKEY  : If x <= WrittenTo Then x:=x+1;
        DELKEY    : If x <= WrittenTo Then Begin
                                              Delete(s,x,1);
                                              WriteString;
                                              WrittenTo:= WrittenTo-1;
                                           End;
        ENDKEY    : x:= WrittenTo + 1;
        UPKEY,
        PGUPKEY,
        DOWNKEY,
        PGDNKEY,
        INSKEY    : Begin End;
      End;
    End
  Else
    ItIsNotAnActionKey:=True;
END;  {PROCEDURE ItIsNotAnActionKey}
PROCEDURE AddCharacter;
BEGIN { PROCEDURE AddCharacter }
  If WrittenTo < x Then Begin
                          S:=S+ch; WrittenTo:=WrittenTo+1; End
                   Else S[x]:=ch;
  x:=x+1;
END;  { PROCEDURE AddCharacter }

BEGIN { PROCEDURE ReadString }
WrittenTo:=Length(s);
WriteString;
x:=1; If CharType=6 Then x:=2;
Repeat
  Repeat
    If (CharType=6) And (x>2) Then GoToXY(x+1,1)
                              Else GoToXY(x,1);
    Ch:=GetKey;
  Until ItIsNotAnActionKey(ch,x,s);
  If Ch <> ENTER Then
    Case CharType Of
      2: If Ch in (DigitSet) Then AddCharacter Else Error(2);
      3: If Ch in (DigitSet + LetterSet) Then AddCharacter Else Error(3);
      4: Case Ch Of     '0','r','R' : s:='0';
                        '1','f','F' : s:='1';
         Else Error(4); End;
      5: Case Ch Of     '1','c','C' : s:='1';
                        '2','l','L' : s:='2';
                        '3','m','M' : s:='3';
         Else Error(5); End;
      6: If (Ch in DigitSet) Or (x=1)
         Then Begin
             If x=1 Then If Ord(ch)<>45 Then Ch:=' ';
             If x=2 Then Ch:= Char(Ord(Ch)+1);
             AddCharacter;
           End
         Else Error(2);
    End;
    WriteString;
  If x>Space Then x:=x-1;
Until (Ch=ENTER);
END;  { PROCEDURE ReadString }

FUNCTION ReadChoice(max:Byte):Char;
VAR      OK : Boolean;
         Ch, BiggestChoice : Char;
BEGIN { FUNCTION ReadChoice }
  InitWrite(1,25,WHITE,GREENback);Write(' >   ');
  GoToXY(4,25);
  OK:= False;
  Repeat
    Ch:=GetKey;
    If (max<255) And ((Ch in DigitSet) And (Ord(Ch)-48<= max)) Then OK:=True;
    If (max<255) And (Ch = HELP) Then OK:= True;
    If (max=255) And (Ch in HELPset) Then OK:= True;
    GoToXY(4,25);Write(ch);GoToXY(4,25);
  Until OK;
  ReadChoice:=ch;
  TextBackground(BLACK);
END;  { FUNCTION ReadChoice }

PROCEDURE ReadNumber(Space,CharType:Byte; var Result:LongInt;
                     RangeMin:LongInt; RangeMax:Longint);
Var      s: String;
         number :longint;
         Dummy : integer;
         pos:boolean;
BEGIN { PROCEDURE ReadNumber }
Repeat
  If CharType=6 Then Begin
                       If Result<0 Then Pos:= False Else Pos:= True;
                       Result:= Abs(Result) + 100;
                       Str(Result:3,s);
                       s:=Concat(' ',s);
                       If Pos then s[1]:='+' Else s[1]:='-';
                     End
                Else Str(Result,s);
  ReadString(Space,CharType,s);
  If CharType=6 Then Begin
                       If s[1]='-' Then Pos:=False Else Pos:= True;
                       Delete(s,1,1);
                       Val(s,number,dummy);
                       Number:= Number-100;
                       If Not Pos Then Number:= (-1) * Number;
                     End
                Else Val(s,number,dummy);
  If (number < RangeMin) Or (number > RangeMax) Then Error(6)
                                                Else Begin
                                                       Error(0);
                                                       Result:=Number;
                                                     End;
Until OK;
END;  { PROCEDURE ReadNumber }

PROCEDURE ReadFileName(x,y:byte;var FileName:String);
VAR      Col : Byte;
         s : String;
         Ch : Char;
BEGIN { Proc ReadFileName }
  SetWindow(x,y,15,1,GREENback); ClrScr;
    GoToXY(2,1); Write('>'); GoToXY(12,1); Write('.IN');
  SetWindow(x+3,y,9,1,GREENback);
    s:=FileName;
    ReadString(8,3,s);
    If S <> '' Then Filename:=s;
END;  { Proc ReadFileName }

{*********************************************}
{*********************************************}
{ ------------- Queue Handling -------------- }
{*********************************************}
{*********************************************}

PROCEDURE DeleteElementOfQueue(Var Queue:QueueType; No :Byte);
VAR      Row:Byte;
BEGIN { PROCEDURE DeleteElementOfQueue }
  If (No <= Queue.Dim) And (No>0)
  Then Begin
      Queue.Data[No]:=NULL;
      Queue.Dim:= Queue.Dim-1;
      For Row:= No To Queue.Dim Do
        Queue.Data[Row] := Queue.Data[Row+1];
    End;
END;  { PROCEDURE DeleteElementOfQueue }

FUNCTION PickFirstElementOfQueue(Var Queue:QueueType): String;
BEGIN { FUNCTION PickFirstElementOfQueue }
  If Queue.Dim=0
  Then PickFirstElementOfQueue:= NULL
  Else Begin
      PickFirstElementOfQueue:= Queue.Data[1];
      DeleteElementOfQueue(Queue,1);
    End;
END;  { FUNCTION PickFirstElementOfQueue }

PROCEDURE AddElementToQueue(Var Queue:QueueType; s:String);
BEGIN { PROCEDURE AddElementToQueue }
  If Queue.Dim < DimQueue
  Then Begin
      Queue.Dim:=Queue.Dim+1;
      Queue.Data[Queue.Dim]:=s;
    End
  Else Error(14);
END;  { PROCEDURE AddElementToQueue }

PROCEDURE WriteQueue(x,y:Byte; Var Queue:QueueType; FileType:String;
                     Color:Byte);
Var      Row:Byte;
BEGIN { PROCEDURE WriteQueue }
  SetWindow(x,y,34,20,Color);ClrScr;
  If Queue.Dim = 0 Then Begin GoTOXY(4,6); Write('The Queue is EMPTY !') END;
  For Row:= 1 To Trunc(Queue.Dim/2) Do
    Begin
      GoToXY(1,Row);Write((2*Row-1):2,'. ',Queue.Data[2*Row-1],'.',FileType);
      GoToXY(18,Row);Write((2*Row):2,'. ',Queue.Data[2*Row],'.',FileType);
    End;
  If Odd(Queue.Dim) Then
    Begin
      GoToXY(1,Trunc((Queue.Dim+1)/2));
      Write(Queue.Dim:2,'. ',Queue.Data[Queue.Dim],'.',FileType);
    End;
  SetWindow(1,1,80,25,BLACK);
END;  { PROCEDURE WriteQueue }

{********************************************}
{********************************************}
{-------------- File Handling  --------------}
{********************************************}
{********************************************}

PROCEDURE Save(FileName :String);
Var      IOFile:Text;
PROCEDURE WritelnCorrection(var Cor: CorrectionType);
Var      i:Byte;
BEGIN { PROCEDURE WritelnCorrection }
  For i:= 1 To DimLinePiece Do
      Begin
        Write(IOFile,Cor[i].y1,' ');
        Write(IOFile,Cor[i].x2,' ');
        Write(IOFile,Cor[i].y2,' ');
      End;
  Writeln(IOFile);
END;  { PROCEDURE WritelnCorrection }
BEGIN { PROCEDURE Save }
  Assign(IOFile,ConCat(FileName,'.IN'));
  Rewrite(IOFile);
    Write(IOFile,'93.8.12 is the input file version.');
          Writeln(IOFile,' Be careful with the format of this file.');
    If DimLinePiece = 3
      Then Writeln(IOFile,'*')
      Else Writeln(IOFile,DimLinePiece,'   Note that DimLinepiece has been changed in the Source Code !');
    Write(IOFile,Ord(FixedRandomStart),'          = Fixed Random Start,');
          Writeln(IOFile,' 1=True, 0=False');
    Writeln(IOFile,N,'          = N');
    Writeln(IOFile,T,'          = T');
    Writeln(IOFile,DimNonStat,'          = # non stationary directions');
    Writeln(IOFile,DimUnResTrend,'          = # drift functions with UnRestricted parameter');
    Writeln(IOFile,DimTrendStat,'          = # drift functions with Restricted parameter');
    Writeln(IOFile,DimConditionalVar,'          = # conditional variables in a partial system');
    Writeln(IOFile,'The first  drift function with UnRestricted parameter:');
        WritelnCorrection(Reg1);
    Writeln(IOFile,'The second drift function with UnRestricted parameter:');
        WritelnCorrection(Reg2);
    Writeln(IOFile,'The third  drift function with UnRestricted parameter:');
        WritelnCorrection(Reg3);
    Writeln(IOFile,'The first  drift function with Restricted parameter:');
        WritelnCorrection(Res1);
    Writeln(IOFile,'The second drift function with Restricted parameter:');
        WritelnCorrection(Res2);
    Writeln(IOFile,'The third  drift function with Restricted parameter:');
        WritelnCorrection(Res3);
  Close(IOFile);
  AddElementToQueue(Queue,FileName);
END;  { PROCEDURE Save }

PROCEDURE Load(FileName :String; var Code:Byte);
{ Error Codes :
  0:  OK.
  10: Non exist file or empty file.
  11: Syntax error.
  12: Syntax error.  Maybe The Source Code has been changed such
                     DimLinePiece > 6
}
Var      InFile:Text;
         s: String;
         Ch: Char;
PROCEDURE Tjek;
BEGIN { PROCEDURE Tjek }
  If IOResult <> 0 Then Code:= 11;
END;  { PROCEDURE Tjek }
PROCEDURE ReadCorrection(var Cor: CorrectionType);
Var      i:Byte;
BEGIN { PROCEDURE ReadCorrection }
  For i:= 1 To DimLinePiece Do
    With Cor[i] Do Begin
        Read(InFile,y1);
        Read(InFile,x2);
        Read(InFile,y2);
      End;
END;  { PROCEDURE ReadCorrection }
BEGIN { PROCEDURE Load }
  Code:=0;
  {$I-}
  Assign(InFile,ConCat(FileName,'.IN'));
  Reset(InFile);
    If (IOResult <> 0) Or (EoF(InFile)=True)
    Then Code:=10
    Else Begin
      Readln(InFile,s);
      If not (s= ConCat('93.8.12 is the input file version.',
                    ' Be careful with the format of this file.'))
                                                Then Code:=11;
      If Code = 0
      Then Begin Readln(InFile,Ch);
                 Case Ch Of '*','1','2','4','5','6' : Begin End;
                            Else Code:=12;
                            End;
           End;
      Tjek; If Code = 0 Then Begin
                             Read(InFile,Ch);
                             Case Ch Of
                               '0' : FixedRandomStart:=False;
                               '1' : FixedRandomStart:=True;
                             Else Code:=11;
                             End;
                             Readln(InFile);
                           End;
      Tjek; If Code = 0 Then Read(InFile,N);                  Readln(InFile);
      Tjek; If Code = 0 Then Read(InFile,T);                  Readln(InFile);
      Tjek; If Code = 0 Then Read(InFile,DimNonStat);         Readln(InFile);
      Tjek; If Code = 0 Then Read(InFile,DimUnResTrend);      Readln(InFile);
      Tjek; If Code = 0 Then Read(InFile,DimTrendStat);       Readln(InFile);
      Tjek; If Code = 0 Then Read(InFile,DimConditionalVar);  Readln(InFile);
      Readln(InFile);
      Tjek; If Code = 0 Then ReadCorrection(Reg1);            Readln(InFile);
      Readln(InFile);
      Tjek; If Code = 0 Then ReadCorrection(Reg2); Readln(InFile);
      Readln(InFile);
      Tjek; If Code = 0 Then ReadCorrection(Reg3); Readln(InFile);
      Readln(InFile);
      Tjek; If Code = 0 Then ReadCorrection(Res1); Readln(InFile);
      Readln(InFile);
      Tjek; If Code = 0 Then ReadCorrection(Res2); Readln(InFile);
      Readln(InFile);
      Tjek; If Code = 0 Then ReadCorrection(Res3); Readln(InFile);
      Tjek;
      Close(InFile);
    End;
  {$I+}
  FileMode:=2;
END;  { PROCEDURE Load }

{*********************************************}
{*********************************************}
{ -------------- The Menu Pages ------------- }
{*********************************************}
{*********************************************}

PROCEDURE HelpPage(TextNo : Byte);
VAR      ExitHelp : Boolean;
         Ch : Char;
         LineNoBegin, LineNoEnd, ScreenLineNoBegin : Word;
         IOFile : Text;
  PROCEDURE WriteHelpPage(var LineNoBegin, LineNoEnd : Word);
  Var      IOFile     : Text;
           LineNo     : Word;
           LineString : String;
           w          : WindowAttr;
  BEGIN { PROCEDURE WriteHelpPage }
    SaveWindow(w);
    SetWindow(3,3,76,19,BLUE);ClrScr;
    SetWindow(4,4,74,18,BLUE);
    Assign(IOFile,'DisCo.Hlp'); Reset(IOFile);
      For LineNo:= 1 To (LineNoBegin-1) Do
        ReadLn(IOFile);
      For LineNo:= 1 To 17 Do
        Begin
          Readln(IOFile,LineString);
          If (LineNo + LineNoBegin - 1) <= LineNoEnd
          Then Writeln(LineString);
        End;
    Close(IOFile);
    RestoreWindow(w);
  END;  { PROCEDURE WriteHelpPage }
BEGIN { PROCEDURE HelpPage }
{$I-}
  Assign(IOFile,'DisCo.Hlp');Reset(IOFile);
{$I+}
  If IOResult = 0
  Then Begin
      If TextNo = 1 Then SetPageBegin('Page 1  *  Short about DisCo')
                    Else SetPageBegin('?  *  Help');
      GoToXY(4,23); Write('0. Exit help');
        For ScreenLineNoBegin:= 1 To (27+TextNo) Do Readln(IOFile);
        Readln(IOFile,LineNoBegin,LineNoEnd);
      Close(IOFile);
      ScreenLineNoBegin:= LineNoBegin;
      WriteHelpPage(ScreenLineNoBegin,LineNoEnd);
      ExitHelp:= False;
      Repeat
        Ch:= ReadChoice(255);
        Case Ch Of
          '0'     : ExitHelp:= True;
          UPKEY   : If ScreenLineNoBegin > LineNoBegin
                                 Then ScreenLineNoBegin:= ScreenLineNoBegin-1;
          DOWNKEY : If ScreenLineNoBegin < LineNoEnd
                                 Then ScreenLineNoBegin:= ScreenLineNoBegin+1;
          PGUPKEY : If ScreenLineNoBegin > (LineNoBegin+9)
                                 Then ScreenLineNoBegin:= ScreenLineNoBegin-10
                                 Else ScreenLineNoBegin:= LineNoBegin;
          PGDNKEY : If ScreenLineNoBegin < (LineNoEnd-15)
                                 Then ScreenLineNoBegin:= ScreenLineNoBegin+10;
        End;
        WriteHelpPage(ScreenLineNoBegin,LineNoEnd);
      Until ExitHelp;
    End
  Else Error(21);
END;  { PROCEDURE HelpPage }

PROCEDURE PageStart;
Var     Dummy: Byte;
BEGIN { PROCEDURE PageStart }
  SetWindow(1,1,80,25,BLACK);ClrScr;
  SetWindow(14,6,50,14,BLUE);ClrScr;
    InitWrite(9,2,WHITE,BLUE);  Write('Welcome to the simulation program');
    GoToXY(22,5); Write('DISCO');
    Dummy:= Length(VersionAndDate); Dummy:= Trunc((50-Dummy)/2);
    GoToXY(Dummy,8);  Write(VersionAndDate);
    GoToXY(6,10); Write('which simulates distributions useful in');
    GoToXY(15,11);Write('cointegration analysis');
    GoToXY(12,13); Write('To continue - Press any key !');
  SetWindow(1,1,80,25,BLACK);InitWrite(1,1,LIGHTBLUE,BLACK);
    GoToXY(4,22);   Write('By Bent Nielsen');
    GoToXY(4,23);   Write('Nuffield College, Oxford OX1 1NF, UK');
    GoToXY(4,24);   Write('Email: bent.nielsen@nuf.ox.ac.uk');
    GoToXY(4,25);   Write('http://www.nuff.ox.ac.uk/Users/Nielsen');
  InitWrite(1,1,WHITE,BLACK);
  Choice:=ReadKey;
  GlobalInitializeVariables;
END;  { PROCEDURE PageStart }

PROCEDURE PageQueueEmpty;
Var      Ch:Char;
BEGIN { PROCEDURE PageQueueEmpty }
  If ColourScreen Then
  Begin
    SetWindow(44,2,26,1,BLUE);ClrScr;
      GoToXY(3,1);Write('The queue is now empty');
    SetWindow(47,25,19,1,GREENback);ClrScr;
      Write('  Press any key !');
    Ch:= ReadKey;
    SetWindow(40,1,34,25,BLUE);ClrScr;
      GoToXY(7,2);Write('The queue is now empty');
      GoToXY(4,3);Write('The results are written in:');
    WriteQueue(40,5,ResultQueue,'OUT',BLUE);
  End;
  SetWindow(47,25,19,1,GREENback);ClrScr;
    Write('  Press any key !');
  Ch:= ReadKey;
END;  { PROCEDURE PageQueueEmpty }

PROCEDURE PageExit;
BEGIN { PROCEDURE PageExit }
  SetWindow(1,1,80,25,BLACK);ClrScr;
  SetWindow(20,6,40,9,BLUE);ClrScr;
    GoToXY(11,2);  Write('If You want to leave');
    GoToXY(18,5);  Write('DISCO');
    GoToXY(9,8);   Write('press any key except "0"');
  SetWindow(1,1,80,25,BLACK);InitWrite(1,1,LIGHTBLUE,BLACK);
  InitWrite(1,1,WHITE,BLACK);
    GoToXY(4,22);   Write('By Bent Nielsen');
    GoToXY(4,23);   Write('Nuffield College, Oxford OX1 1NF, UK');
    GoToXY(4,24);   Write('Email: bent.nielsen@nuf.ox.ac.uk');
    GoToXY(4,25);   Write('http://www.nuff.ox.ac.uk/Users/Nielsen');
  Choice:= ReadKey;
  ExitProgram:=True;
  ExitUnit:=True;
  If Choice='0' then Begin
                       ExitProgram:=False;
                       ExitUnit:=False;
                     End
END;  { PROCEDURE PageExit }

PROCEDURE Page2;
Var      Choice:Char;
         Dummy:Integer;
         F:Text;
         ToPage0: Boolean;
BEGIN { PROCEDURE Page2 }
  Repeat
    SetPageBegin('Page 2  *  Edit a Job');

    GoToXY(4,23); Write('0. Accept');
    GoToXY(4,21); Write('?  Help');
    GoToXY(4,4);  Write('Job file ',FileName,'.IN           Result file ',FileName,'.OUT');
    GoToXY(4,6);
      Write('1. The starting value of the random generator should be ');
      TextColor(GREENtext); If FixedRandomStart Then Write('Fixed') Else Write('Randomized');
    GoToXY(4,8);
      TextColor(WHITE); Write('2.                                                  N = ');
      TextColor(GREENtext); Write(N);
    GoToXY(4,10);
      TextColor(WHITE); Write('3.                                                  T = ');
      TextColor(GREENtext); Write(T);
    GoToXY(4,12);
      TextColor(WHITE); Write('4.                     # of non-stationary directions = ');
      TextColor(GREENtext); Write(DimNonStat);
    GoToXY(4,14);
      TextColor(WHITE); Write('5.  # of drift functions with UnRestricted parameters = ');
      TextColor(GREENtext); Write(DimUnResTrend);
    GoToXY(4,16);
      TextColor(WHITE); Write('6.    # of drift functions with Restricted parameters = ');
      TextColor(GREENtext); Write(DimTrendStat);
(*    GoToXY(4,18);
      TextColor(WHITE); Write('7.     # of Conditional variables in a partial system = ');
      TextColor(GREENtext); Write(DimConditionalVar);
*)
    Error(0);

{ Non Fatal Error : The sort procedure in unit SORT does only calculate
  fractiles for proper values of N. }
    If Not( (N<=10000) Or (N mod 10000 = 0) )            Then Error(10);
(*
{ Fatal Error : Dimension of system is too high. }
    If ( DimNonStat + DimConditionalVar > 17 )           Then Error(16);
*)

{ Fatal Error : Dimension of system is too high. }
    If ( DimNonStat > 17 )                               Then Error(22);

{ Fatal Error : gives singularities when handling matrices. }
    If T<= DimNonStat + DimTrendStat                     Then Error(7);

{ Fatal Error : overidentified system. }
    If DimNonStat < DimUnResTrend                        Then Error(8);

{ Fatal Error : Not sufficient free bytes for the temporary file ERASEME.
  On this file "Nspace" (constant) Bytes is required for each repetition,
  and "Dimqueue" (constant) * 1600 bytes for the in/out putfiles.  }
    If (DiskFree(0) < (N * Nspace + DimQueue * 1600 ))
    Then Begin
           Assign(f,'ERASE.ME'); {$I-} Reset(f); {$I+}
           If IOResult = 0 Then Begin Close(f); Erase(f) End;
           If (DiskFree(0) < (N * Nspace + DimQueue * 1600 ))   Then Error(11);
         End;

    ToPage0:= OK;

      Choice:=ReadChoice(6);

      If Choice <> '0'
      Then Begin
        ToPage0:= False;
        SetWindow(30,19,25,3,GREENback); ClrScr;
        Write(' Range: ');
        GoToXY(5,3);Write('>');GotoXY(10,1);
        Case Choice Of
          '1' : Write(RanRange);
          '2' : Write(NRange);
          '3' : Write(TRange);
          '4' : Write(DimNonStatRange);
          '5' : Write(DimUnResTrendRange);
          '6' : Write(DimTrendStatRange);
          '7' : Write(DimConditionalVarRange);
        End;
        SetWindow(36,21,11,1,GREENback);
        Case Choice Of
          '1' : Begin
                  If FixedRandomStart Then s:='1' Else s:='0';
                  ReadString(10,4,s);
                  Case s[1] Of  '0': FixedRandomStart:= False;
                                '1': FixedRandomStart:= True;
                  End;
                End;
          '2' : ReadNumber(7,2,N,Nmin,Nmax);
          '3' : ReadNumber(3,2,T,TMin,TMax);
          '4' : ReadNumber(2,2,DimNonStat,DimNonStatMin,DimNonStatMax);
          '5' : ReadNumber(1,2,DimUnResTrend,DimUnResTrendMin,MinLongInt(DimNonStat,3));
          '6' : ReadNumber(2,2,DimTrendStat,DimTrendStatMin,DimTrendStatMax);
          '7' : ReadNumber(2,2,DimConditionalVar,DimConditionalVarMin,(17-DimNonStat));
          HELP : HelpPage(3);
        End;
        ResetWindow(30,19,25,3);
      End;

    Until ToPage0;
END;  { PROCEDURE Page2 }

FUNCTION ZeroVectorOK(var Cor:CorrectionType; var DimCor :LongInt):Boolean;
VAR      Result:Boolean;
         i :Byte;
         Ch:Char;
BEGIN { FUNCTION ZeroVectorOK }
  Result:=False;
  For i:= 1 To DimLinePiece Do
    If (Cor[i].y1<>0) Or (Cor[i].y2<>0) Then Result:=True;
  If Result=False
  Then Begin
      Error(9);
      Ch:=ReadKey;
      If Ch <> ESCAPE Then Begin
                             DimCor:= DimCor-1;
                             Result:=True;
                           End;
      Error(0);
    End;
  ZeroVectorOK:=Result;
END;  { FUNCTION ZeroVectorOK }

PROCEDURE Page3;
VAR      Num :LongInt;
         Row : Byte;
         RankOK, ToPage0, ChoiceOK: Boolean;
         Ch: Char;
  PROCEDURE Page3a(var Cor:CorrectionType; var DimCor:LongInt);
  Var      ToPage3: Boolean;
           i,j,k,RangeMin,RangeMax:ShortInt;
           s:String;
           No:LongInt;
    PROCEDURE MakeGraph;
      VAR    IgnoreGraph: Boolean;
             GraphDriver, GraphMode, ErrorCode: Integer;
             i:Byte;
             Ch: Char;
      PROCEDURE GraphBegin(var IgnoreGraph: Boolean);
      BEGIN { PROCEDURE GraphBegin }
        IgnoreGraph:= False;
        DetectGraph(GraphDriver,GraphMode);
        If (GraphDriver = VGA) And
           (RegisterBGIdriver(@EGAVGADriverProc) >= 0)
        Then Begin
             InitGraph(GraphDriver,GraphMode,'C:\TMP\');
             Line(100,260,540,260);
             Line(535,257,540,260);
             Line(535,263,540,260);
             Line(115,70,115,450);
             Line(112,75,115,70);
             Line(118,75,115,70);
             Line(215,257,215,263);
             Line(315,257,315,263);
             Line(415,257,415,263);
             Line(515,257,515,263);
             Line(112,100,118,100);
             Line(112,140,118,140);
             Line(112,180,118,180);
             Line(112,220,118,220);
             Line(112,300,118,300);
             Line(112,340,118,340);
             Line(112,380,118,380);
             Line(112,420,118,420);
             OutTextXY(515,268,'1');
             OutTextXY(100,97,'1');
             OutTextXY(95,417,'-1');
             SetFillStyle(1,GREENBack);
             Bar(480,459,639,479);
             OutTextXY(500,465,'Press any Key !');
          End
        Else IgnoreGraph:= True;
      END;  { PROCEDURE GraphBegin }
      PROCEDURE PlotLinePiece(No:Byte; x1,y1,x2,y2 :Single);
      VAR      NoStr,x1Str,y1Str,x2Str,y2Str :String;
      BEGIN { PROCEDURE PlotLinePiece }
             Str(No:1,NoStr);
             Str(x1:4:2,x1Str);
             Str(y1:5:2,y1Str);
             Str(x2:4:2,x2Str);
             Str(y2:5:2,y2Str);
             SetColor(White);
             OutTextXY(0,(No-1)*10,Concat('LinePiece No ',NoStr,
                                          ': (',x1Str,',',y1Str,') -> (',
                                                x2Str,',',y2Str,')'
                                         ));
             SetLineStyle(0,0,3);
             SetColor(REDline);
             Line(Trunc(115+x1*400),Trunc(260-y1*160),
                  Trunc(115+x2*400),Trunc(260-y2*160));
             SetLineStyle(0,0,1);
             SetColor(LightBlue);
             SetFillStyle(1,LightBlue);
             PieSlice(Trunc(115+x1*400),Trunc(260-y1*160),0,360,3);
             SetColor(Black);
             SetFillStyle(1,Black);
             PieSlice(Trunc(115+x2*400),Trunc(260-y2*160),0,360,3);
             SetColor(LightBlue);
             Circle(Trunc(115+x2*400),Trunc(260-y2*160),3);
             SetColor(White);
      END;  { PROCEDURE PlotLinePiece }
    BEGIN {MakeGraph}
      GraphBegin(IgnoreGraph);
      If Not (IgnoreGraph)
      Then Begin
          PlotLinePiece(1,0,Cor[1].y1/100,Cor[1].x2/100,Cor[1].y2/100);
          For i:= 2 To DimLinePiece Do
            If Cor[i].x2<>0
            Then
              PlotLinePiece(i,Cor[i-1].x2/100,Cor[i].y1/100,
                              Cor[i].x2/100,Cor[i].y2/100);
          Ch:=ReadKey;
          CloseGraph;
        End
      Else Error(17);
    END;  {MakeGraph}
  BEGIN { PROCEDURE Page3a }
    ToPage3:=False;
    Repeat
      SetPageBegin('Page 3a  *  Mixed Drift');
      GoToXY(4,23); Write('0.  Accept and Return to Page 3');
      GoToXY(4,21); Write('?   Help');
      For i:=1 To DimLinePiece Do
        If Cor[i].x2 <> 0 Then Begin
          GoToXY(4,i+3);
            Write(i,'.  LinePiece No ',i,':  (');
            If i>1 Then Write((Cor[i-1].x2/100):4:2) Else Write('0.00');
            Write(',',(Cor[i].y1/100):5:2);
            Write(') -> (',(Cor[i].x2/100):4:2);
            Write(',',(Cor[i].y2/100):5:2,')');
        End;
      GoToXY(4,16); Write('7.  Plot of the Function');

      Choice:= ReadChoice(7);
      i:=0;
      Case Choice Of
        '0' : ToPage3:=ZeroVectorOK(Cor,DimCor);
        '7' : MakeGraph;
        HELP : HelpPage(5);
        Else
          For j:= 1 To DimLinePiece Do
            If (Choice=Chr(48+j)) And (Cor[j].x2 <> 0) Then i:= j;
      End;
      If i>0 Then
      Begin
        SetWindow(29,19,23,3,GREENback);ClrScr;
        GoToXY(1,1); Write('        Input Of');
        GoToXY(1,2); Write('     LinePiece No ',i:1);
        GoToXY(1,3); Write('     x1 = ');
        If i=1 Then Write(' 0')
               Else Write((Cor[i-1].x2/100):5:2);
        SetWindow(1,1,80,25,Black);
        GoToXY(4,i+3);
          Write(i,'.  LinePiece No ',i,':  (');
          TextColor(GreenText);
          If i>1 Then Write((Cor[i-1].x2/100):4:2) Else Write('0.00');
          TextColor(White);
          Write(',',(Cor[i].y1/100):5:2);
          Write(') -> (',(Cor[i].x2/100):4:2);
          Write(',',(Cor[i].y2/100):5:2,')');
        Ch:= ReadKey;
        For j:=1 To 3 Do
        Begin
          SetWindow(1,1,80,25,Black);
          GoToXY(4,i+3);
          Write(i,'.  LinePiece No ',i,':  (');
          If i>1 Then Write((Cor[i-1].x2/100):4:2) Else Write('0.00');
          Write(',',(Cor[i].y1/100):5:2);
          Write(') -> (',(Cor[i].x2/100):4:2);
          Write(',',(Cor[i].y2/100):5:2,')');
          TextColor(GreenText);
          Case j Of
            1 : Begin GotoXY(31,i+3); Write((Cor[i].y1/100):5:2); End;
            2 : Begin GotoXY(42,i+3); Write((Cor[i].x2/100):4:2); End;
            3 : Begin GotoXY(47,i+3); Write((Cor[i].y2/100):5:2); End;
          End;
          TextColor(White);
          Case j Of
            1 : Begin s:='y1'; RangeMin:=-100; No:=Cor[i].y1; RangeMax:=100 End;
            2 : Begin s:='x2';
                      If i=1 Then RangeMin:=(0+1) Else RangeMin:= (Cor[i-1].x2+1);
                      No:= Cor[i].x2;
                      If i<DimLinePiece Then RangeMax:= Cor[i+1].x2;
                      If (i=DimLinePiece) Then
                                       Begin RangeMin:=100; RangeMax:=100; End;
                      If RangeMax=0 Then RangeMax:=100;
                End;
            3 : Begin s:='y2'; RangeMin:=-100; No:=Cor[i].y2; RangeMax:=100 End;
          End;
          SetWindow(29,19,23,3,GREENback);ClrScr;
            Write(' Range: ',(RangeMin/100):4:2,' -> ',(RangeMax/100):4:2);
            GoToXY(6,3); Write(s,' >');
          SetWindow(39,21,6,1,GREENback);
            ReadNumber(5,6,No,RangeMin,RangeMax);
          Case j Of
            1 : Cor[i].y1:= No;
            2 : Cor[i].x2:= No;
            3 : Cor[i].y2:= No;
          End;
          GoToXY(4,i+3);
          Write(i,'.  LinePiece No ',i,':  (');
          If i>1 Then Write((Cor[i-1].x2/100):4:2) Else Write('0.00');
          Write(',',(Cor[i].y1/100):5:2);
          Write(') -> (',(Cor[i].x2/100):4:2);
          Write(',',(Cor[i].y2/100):5:2,')');
          TextColor(GreenText);
          Case j Of
            1 : Begin GotoXY(31,i+3); Write((Cor[i].y1/100):5:2); End;
            2 : Begin GotoXY(42,i+3); Write((Cor[i].x2/100):4:2); End;
            3 : Begin GotoXY(47,i+3); Write((Cor[i].y2/100):5:2); End;
          End;
          TextColor(White);
        End;
        If i<DimLinePiece
        Then If Cor[i].x2<100
             Then If (Cor[i+1].x2=0)
                  Then With Cor[i+1] Do Begin
                                 y1:= Cor[i].y2;
                                 x2:= 100;
                                 y2:= Cor[i].y2;
                               End
                  Else
             Else For k:=(i+1) To DimLinePiece Do
                        With Cor[k] Do Begin
                          y1:=0;
                          x2:=0;
                          y2:=0;
                        End;
      End;
      ResetWindow(29,19,23,3);
    Until ToPage3;
  END;  { PROCEDURE Page3a }

  PROCEDURE Evaluate(var Cor: CorrectionType; var DimCor: LongInt; No : Byte);
  VAR      i:Byte;
  BEGIN { PROCEDURE Evaluate }
    Case No Of
      1 : Begin
            InitializeCorrection(Cor);
            With Cor[1] Do Begin y1:=100; x2:=100; y2:=100 End;
          End;
      2 : Begin
            InitializeCorrection(Cor);
            With Cor[1] Do Begin y1:=0;   x2:=100; y2:=100 End;
          End;
      3 : Begin
            If Cor[1].x2=0 Then Cor[1].x2:=100;
            Page3a(Cor,DimCor);
          End;
    End;
  END;  { PROCEDURE Evaluate }

  PROCEDURE RankChecking(Var OK:Boolean);
  VAR      Count  :Byte;
           Reg    :pxT_matrix;
           RegReg :pxp_matrix;
           Tword  :Word;
    PROCEDURE CreateRegressor(Var Count: Byte; Var Tword: Word;
                       Var Reg: pxT_matrix; Var RegDescription:CorrectionType);
    VAR     X1,i,Row,CorrectRow:Byte;
            X1T,Col:Word;
            T100,Dummy,Slope:Single;
    BEGIN { PROCEDURE CreateRegressor }
      Count:= Count+1;
      T100:=Tword/100;
      X1:= 0;
      For i:= 1 To DimLinePiece Do
        If RegDescription[i].X2 <> 0
        Then Begin
            Slope:= (RegDescription[i].Y2 - RegDescription[i].Y1)/
                    (RegDescription[i].X2 - X1)/T100;
            X1T:= Trunc(X1*T100);
            For Col:= X1T To Trunc(RegDescription[i].X2*T100) Do
              Begin
                Dummy:= RegDescription[i].Y1 + Slope*(Col-X1T);
                Reg[Count]^[Col]:= Dummy;
              End;
            X1:= RegDescription[i].X2;
          End;
    END;  { PROCEDURE CreateRegressor }
  BEGIN { PROCEDURE RankChecking }
    If T>200 Then Tword:= 200
             Else Tword:= T;
    Count:= 6;
    GetMatrix(Reg,Count);
      Count:= 0;
      If DimUnResTrend>0 Then CreateRegressor(Count,Tword,Reg,Reg1);
      If DimUnResTrend>1 Then CreateRegressor(Count,Tword,Reg,Reg2);
      If DimUnResTrend>2 Then CreateRegressor(Count,Tword,Reg,Reg3);
      If DimTrendStat >0 Then CreateRegressor(Count,Tword,Reg,Res1);
      If DimTrendStat >1 Then CreateRegressor(Count,Tword,Reg,Res2);
      If DimTrendStat >2 Then CreateRegressor(Count,Tword,Reg,Res3);

      SquareToMatrix(Reg,RegReg,Tword,Count);
      CholeskyDecomposition(RegReg,Count,OK);
      Count:= 6;
    DeleteMatrix(Reg,Count);
  END;  { PROCEDURE RankChecking }

BEGIN { PROCEDURE Page3 }
  ToPage0:=False; RankOK:= True;
  Repeat
    SetPageBegin('Page 3  *  Edit Drift Function');

    GoToXY(4,23);
      Write('0. Accept and Save the Job as ',FileName,'.IN');
    GoToXY(4,21); Write('?  Help');
    GoToXY(4,4);
      Write('Job file ',FileName,'.IN          Result file ',FileName,'.OUT');
    GoToXY(4,6);
      Write('N = ',N,',   T = ',T,',   p-r = ',DimNonStat,
                     ',   # UnRes drift = ',DimUnResTrend,
                     ',   # Res drift = ',DimTrendStat);
    GoToXY(4,11);
      If DimUnResTrend > 0 Then Begin
          TextColor(White); Write('1. The first  drift function with UnRestricted parameter is  ');
          TextColor(GREENtext); WriteCorrection(Reg1,num);
          If Num=0 Then ToPage0:= False;
        End;
    GoToXY(4,12);
      If DimUnResTrend > 1 Then Begin
          TextColor(White); Write('2. The second drift function with UnRestricted parameter is  ');
          TextColor(GREENtext); WriteCorrection(Reg2,num);
          If Num=0 Then ToPage0:= False;
        End;
    GoToXY(4,13);
      If DimUnResTrend > 2 Then Begin
          TextColor(White); Write('3. The third  drift function with UnRestricted parameter is  ');
          TextColor(GREENtext); WriteCorrection(Reg3,num);
          If Num=0 Then ToPage0:= False;
        End;
    GoToXY(4,15);
      If DimTrendStat > 0 Then Begin
          TextColor(White); Write('4. The first  drift function with Restricted parameter is  ');
          TextColor(GREENtext); WriteCorrection(Res1,num);
          If Num=0 Then ToPage0:= False;
        End;
    GoToXY(4,16);
      If DimTrendStat > 1 Then Begin
          TextColor(White); Write('5. The second drift function with Restricted parameter is  ');
          TextColor(GREENtext); WriteCorrection(Res2,num);
          If Num=0 Then ToPage0:= False;
        End;
    GoToXY(4,17);
      If DimTrendStat > 2 Then Begin
          TextColor(White); Write('6. The third  drift function with Restricted parameter is  ');
          TextColor(GREENtext); WriteCorrection(Res3,num);
          If Num=0 Then ToPage0:= False;
        End;
    If RankOK=False Then Error(18);
    RankOK:=True;

    ChoiceOK:= False;
    Choice:= ReadChoice(6);
    If Choice = '0'
    Then Begin
           RankChecking(RankOK);
           ToPage0:= RankOK;
         End
    Else Case Choice Of
           HELP: HelpPage(4);
           '1' : If DimUnResTrend>0 Then ChoiceOK:= True;
           '2' : If DimUnResTrend>1 Then ChoiceOK:= True;
           '3' : If DimUnResTrend>2 Then ChoiceOK:= True;
           '4' : If DimTrendStat>0 Then ChoiceOK:= True;
           '5' : If DimTrendStat>1 Then ChoiceOK:= True;
           '6' : If DimTrendStat>2 Then ChoiceOK:= True;
         End;

    If ChoiceOK
    Then Begin
        ToPage0:= False;
        SetWindow(30,19,24,3,GREENback);ClrScr;
          Write('   Choose C, L or M');
          GoToXY(5,3);Write('> ');
          Case Choice Of
            '1' : WriteCorrection(Reg1,num);
            '2' : WriteCorrection(Reg2,num);
            '3' : WriteCorrection(Reg3,num);
            '4' : WriteCorrection(Res1,num);
            '5' : WriteCorrection(Res2,num);
            '6' : WriteCorrection(Res3,num);
          End;

        SetWindow(36,21,11,1,GREENback);
          ReadNumber(1,5,Num,0,3);
          Case Choice Of
            '1' : Evaluate(Reg1,DimUnResTrend,num);
            '2' : Evaluate(Reg2,DimUnResTrend,num);
            '3' : Evaluate(Reg3,DimUnResTrend,num);
            '4' : Evaluate(Res1,DimTrendStat,num);
            '5' : Evaluate(Res2,DimTrendStat,num);
            '6' : Evaluate(Res3,DimTrendStat,num);
          End;
        ResetWindow(30,19,24,3);
      End;
  Until ToPage0;
  Save(FileName);
END;  { PROCEDURE Page3 }

PROCEDURE Page4;
Var      QueueFileName : String;
         No : LongInt;
         ToPage0:Boolean;
BEGIN { PROCEDURE Page4 }
    Repeat
      SetWindow(1,1,80,25,BLACK);ClrScr;
      SetPageBegin('Page 4  *  Simulation');
      GoToXY(4,23); Write('0. To page 0');
      GoToXY(4,4);  Write('1. Start simulations');
      GoToXY(4,7);  Write('2. Add a Job');
      GoToXY(4,8);  Write('3. Delete a Job');
      GoToXY(4,21); Write('?  Help');

      ToPage0:= False;

      InitWrite(49,3,GREENtext,BLACK);Write('Job Queue');
      WriteQueue(40,5,Queue,'IN',BLACK);
      Choice:= ReadChoice(3);
      Case Choice Of
        '0' : ToPage0:= True;
        '1' : Begin
                If Queue.Dim > 0
                Then Begin
                    ExitUnit:=True;
                    ExitProgram:=False;
                    ToPage0:=True;
                    ClrScr;
                  End
                Else Error(15);
              End;
        '2' : If Queue.Dim < DimQueue
              Then Begin
                QueueFileName:= NULL;
                SetWindow(5,15,35,1,GREENback);ClrScr;
                Write(' Name of the order ?');
                ReadFileName(30,15,QueueFileName);
                LOAD(QueueFileName,ErrorCode);
                Case ErrorCode Of
                  0  : AddElementToQueue(Queue,QueueFileName);
                  10 : Error(12);
                  11 : Error(13);
                  12 : Error(19);
                End;
                ResetWindow(5,15,35,1);
              End
              Else Error(14);
        '3' : If Queue.Dim > 0
              Then Begin
                No:=0;
                SetWindow(10,15,25,1,GREENback);ClrScr;
                Write(' Delete Order No.   > ');
                SetWindow(32,15,3,1,GREENback);
                ReadNumber(2,2,No,0,Queue.Dim);
                DeleteElementOfQueue(Queue,No);
                ResetWindow(10,15,25,1);
              End
              Else Error(15);
        HELP : HelpPage(6);
      End;
    Until ToPage0;

END;  { PROCEDURE Page4 }

PROCEDURE Page0;
Var      Choice:Char;
BEGIN { PROCEDURE Page0 }
  ExitUnit:=False;
  Repeat
    SetPageBegin('Page 0');
    GoToXY(4,4);  Write('1. Short about DisCo');
    GoToXY(4,6);  Write('2. Edit a new Job');
    GoToXY(4,8);  Write('3. Initialise Default Values');
    GoToXY(4,10); Write('4. Simulation');
    GoToXY(4,21); Write('?  Help');
    GoToXY(4,23); Write('0. Quit');

    Choice:=ReadChoice(4);
    Case Choice of
    '1' : HelpPage(1);
    '2' : Begin
            GoToXY(37,6); Write('Name of the Job ? ');
            ReadFileName(56,6,FileName);
            Page2;
            Page3;
          End;
    '3' : Begin
            GoToXY(37,8); Write('Name of the Job ? ');
            ReadFileName(56,8,FileName);
            LOAD(FileName,ErrorCode); Case ErrorCode Of
                                        10 : Error(12);
                                        11 : Error(13);
                                      End;
          End;
    '4' : Page4;
    HELP : HelpPage(2);
    '0' : PageExit;
    End;
  Until ExitUnit;
END;  { PROCEDURE Page0 }

END.