UNIT SIM_IO;

(*
         Ŀ
              This is part a of the original source text for the    
                program DisCo, version 1.3 - November 26, 1994      
                                                                    
                                                  
                               SIM_IO.PAS 1.3                       
                                                  
                                                                    
           If you modify this unit, please                          
                                                                    
              (1) Make sure that you have a copy of the original    
                  file.                                             
                                                                    
              (2) Delete this comment (25 lines).                   
                                                                    
           Original size of file:  7916 bytes.                      
         
             Copyright       Bent Nielsen
                             Institute of Mathematical Statistics
                             University of Copenhagen
                             Universitetsparken 5
                             2100 Copenhagen O
                             DK - Denmark
*)

{---- Input and output to the simulations ----------}

{---- Interface ------------------------------------}

INTERFACE

USES     Crt,DOS;

TYPE
         CorrectionType = Array[1..3] of Array[1..7] Of Record
                                                          Y1,X2,Y2 : ShortInt;
                                                        End;
         F_Vector       = Array[-2..24] Of Single;
VAR
         DimX, DimDeltaX, DimTrendStat, DimUnResTrend, DimConditionalVar,
         DimBrownianMotion: byte;
         WantReg, WantTrendStat :CorrectionType;
         N :LongInt;
         T :Word;
         FixedRandomStart :Boolean;
         WantedFractile,Fractile,SdvOnFractile :F_vector;
         F :Integer;

PROCEDURE Input(FileName:String);

PROCEDURE OutPut(FileName:String);

{---- Implementation ----------------------}

IMPLEMENTATION

VAR
         Year,Month,Day,DayOfWeek,Hour,Minute,Second,Sec100: Word;

PROCEDURE Input(FileName:String);
  { 10-7-93.
  }
VAR      i :Byte;
         InFile:Text;
         Ch: Char;
         No, DimLinePiece: Byte;
PROCEDURE ReadBlockCorrection(Var Cor:CorrectionType);
VAR      Row,i :Byte;
BEGIN { PROCEDURE ReadBlockCorrection }
  For Row:= 1 To 3 Do
    Begin
      Readln(InFile);
      For i:=1 To DimLinePiece Do
        Begin
            Read(InFile,Cor[Row,i].Y1);
            Read(InFile,Cor[Row,i].X2);
            Read(InFile,Cor[Row,i].Y2);
        End;
      For i:= (DimLinePiece+1) To 6 Do
        Begin
            Cor[Row,i].Y1:=0;
            Cor[Row,i].x2:=0;
            Cor[Row,i].y2:=0;
        End;
      Readln(InFile);
    End;
END;  { PROCEDURE ReadBlockCorrection }

BEGIN { Proc Input }
  Assign(InFile,ConCat(FileName,'.IN'));
  Reset(InFile);
    Readln(InFile);
    Readln(InFile,Ch); Case Ch Of
                            '*' : DimLinePiece:= 3;
                            '1','2','3','4','5','6','7'
                                : DimLinePiece:= Ord(Ch)-48;
                       End;
    Read(InFile,Ch); Case Ch Of
                         '0' : FixedRandomStart:=False;
                         '1' : FixedRandomStart:=True;
                     End;
                     Readln(InFile);
    Read(InFile,N);                    Readln(InFile);
    Read(InFile,T);                    Readln(InFile);
    Read(InFile,DimDeltaX);            Readln(InFile);
    Read(InFile,DimUnResTrend);        Readln(InFile);
    Read(InFile,DimTrendStat);         Readln(InFile);
    Read(InFile,DimConditionalVar);    Readln(InFile);

    DimBrownianMotion:= DimDeltaX + DimConditionalVar;
    DimX:= DimBrownianMotion + DimTrendStat;

    ReadBlockCorrection(WantReg);
    ReadBlockCorrection(WantTrendStat);
  Close(InFile);

  F                      :=24;
  WantedFractile[0]      :=0;
  WantedFractile[1]      :=0.05;
  WantedFractile[2]      :=0.10;
  WantedFractile[3]      :=0.15;
  WantedFractile[4]      :=0.20;
  WantedFractile[5]      :=0.25;
  WantedFractile[6]      :=0.30;
  WantedFractile[7]      :=0.35;
  WantedFractile[8]      :=0.40;
  WantedFractile[9]      :=0.45;
  WantedFractile[10]     :=0.50;
  WantedFractile[11]     :=0.55;
  WantedFractile[12]     :=0.60;
  WantedFractile[13]     :=0.65;
  WantedFractile[14]     :=0.70;
  WantedFractile[15]     :=0.75;
  WantedFractile[16]     :=0.80;
  WantedFractile[17]     :=0.85;
  WantedFractile[18]     :=0.90;
  WantedFractile[19]     :=0.925;
  WantedFractile[20]     :=0.95;
  WantedFractile[21]     :=0.975;
  WantedFractile[22]     :=0.99;
  WantedFractile[23]     :=0.999;
  WantedFractile[24]     :=1;

  GetDate(Year, Month, Day, DayOfWeek);
  GetTime(Hour,Minute,Second,Sec100);
  GoToXY(50,23); Write('This is the Job "',FileName,'.IN"');
  GoToXY(50,24); Write(Hour:2,':',Minute:2,':',Second:2);
END;  { Proc Input }

PROCEDURE OutPut(FileName : String);
VAR      i: integer;
         IOFile : text;
         YearNew, MonthNew, DayNew, DayOfWeekNew,
         HourNew,MinuteNew,SecondNew,Sec100New : Word;
         Screen: Boolean;
  PROCEDURE WritelnFractile(i:integer);
  BEGIN { PROCEDURE WritelnFractile }
              Write(IOFile,' ',(WantedFractile[i]*100):5:1,' % = ');
              If Fractile[i]>=0 Then Write(IOFile,Fractile[i]:8:3)
                                Else Write(IOFile,'    *   ');
              If i<F Then WriteLn(IOFile);
  END;  { PROCEDURE WritelnFractile }
BEGIN { PROCEDURE OutPut }
  For Screen:= False To True Do
  Begin
    If Screen Then AssignCrt(IOFile)
              Else Assign(IOFile,ConCat(FileName,'.OUT'));
    Rewrite(IOFile);
      If Screen Then For i:=1 To 2 Do Writeln(IOFile);
      Writeln(IOFile,'  * * * Result of Simulation performed by DisCo * * *');
      Writeln(IOFile);
      GetDate(YearNew, MonthNew, DayNew, DayOfWeekNew);
      GetTime(HourNew,MinuteNew,SecondNew,Sec100New);
      Write(IOFile,HourNew:2,':',MinuteNew:2,':',SecondNew:2,
                   '  (',YearNew:4,'.',MonthNew:2,'.',DayNew:2,')');
      WriteLn(IOFile,'   started at   ',Hour:2,':',Minute:2,':',Second:2,
                     '  (',Year:4,'.',Month:2,'.',Day:2,')');
      If Not Screen Then WriteLn(IOFile);
      WriteLn(IOFile,'Input Data :');
      WriteLn(IOFile,'N = ',N,',  T= ',T,',');
      WriteLn(IOFile,'# NonStat     = ',DimDeltaX:2);
      WriteLn(IOFile,'# UnRes drift = ',DimUnResTrend:2,
                     ',  # Res drift   = ',DimTrendStat:2,'.');
  {}  If Screen
      Then Begin WriteLn(IOFile,'The data are stored in the file');
                WriteLn(IOFile,'                      "',FileName,'.OUT"'); End
      Else Begin WriteLn(IOFile);
                 WriteLn(IOFile,'This is the file ','"',FileName,'.OUT"'); End;
      WriteLn(IOFile);
        Write(IOFile,'    Mean = ',Fractile[-1]:8:3);
  {}  If Screen
      Then WriteLn(IOFile,'   ( ',(2*Sqrt(Fractile[-2]/N)):8:3,' )')
      Else WriteLn(IOFile,'    2*sdv(Mean) = ',(2*Sqrt(Fractile[-2]/N)):8:3);
      Writeln(IOFile,'Variance = ',Fractile[-2]:8:3);
      For i:= 0 To F Do
        If Screen
        Then Case i of 0,10,20,24: WritelnFractile(i) End
        Else WritelnFractile(i);
      If Screen Then For i:= 1 to 7 Do Writeln(IOFile);
    Close(IOFile);
  End;
END;  { PROCEDURE OutPut }

END.