UNIT SORT;

(*
         Ŀ
              This is a part of the original source text for the    
                   program DisCo, version 1.1 - April 1994          
                                                                    
                                                  
                                SORT.PAS 1.0                        
                                                  
                                                                    
           If you modify this unit, please                          
                                                                    
              (1) Make sure that you have a copy of the original    
                  file.                                             
                                                                    
              (2) Delete this comment (25 lines).                   
                                                                    
           Original size of file:  5155 bytes.                      
         
             Copyright       Bent Nielsen
                             Institute of Mathematical Statistics
                             University of Copenhagen
                             Universitetsparken 5
                             2100 Copenhagen O
                             DK - Denmark
*)

{---- Interface ---------------------------}

INTERFACE

USES     Sim_IO;

PROCEDURE FindFractiles(var N :LongInt; FileName :String; var F :Integer;
                        var Fracs :F_Vector; Var FracVector:F_Vector);

{---- Implementation ----------------------}

IMPLEMENTATION

CONST    Nmax = 10000;     { Remark  1 single variable equals   4 byte
                                     10000 single variables equal 40,000 B
                                               + something to array structure
                             So: limit is 10000   }

TYPE     N_Vector    = Array[1..Nmax] of Single;

VAR    InPut:       Text;

PROCEDURE Moments(var N: LongInt; var FracVector:F_Vector);
  Var  M1,M2,Dum:   Single;
       i           :word;
BEGIN { Moments }
  M1:=0; M2:=0;
    Repeat
      Read(InPut,Dum);
      M1:= M1 + Dum;
      M2:= M2 + sqr(Dum);
    Until EOLN(InPut);
  M1:= M1/N;
  FracVector[-1]:= M1;
  FracVector[-2]:= M2/N - sqr(M1);
END;  { Moments }
PROCEDURE quicksort(var Data: N_Vector; var N: Word);

PROCEDURE sort(l,r: word);
VAR
  i,j: word;
  x, y : Single;
BEGIN
  i:=l; j:=r; x:=Data[(l+r) DIV 2];
  REPEAT
    WHILE Data[i]<x DO i:=i+1;
    WHILE x<Data[j] DO j:=j-1;
    IF i<=j THEN
    BEGIN
      y:=Data[i]; Data[i]:=Data[j]; Data[j]:=y;
      i:=i+1; j:=j-1;
    END;
  UNTIL i>j;
  IF l<j THEN sort(l,j);
  IF i<r THEN sort(i,r);
END;

BEGIN {quicksort};
  sort(1, N);
END;

PROCEDURE SortFile(N: Word; var F :Integer;
                   var Fracs :F_Vector; Var FracVector:F_Vector);
Var     Row : Integer;
        Data: N_Vector;

FUNCTION Fractile(x:real):Single;
  Var   Dum: Word;
BEGIN  { Fractile }
  Dum:= Trunc(x*N);
  If Dum=0 Then
    Dum:=1;
  Fractile:= Data[Dum];
END;   { Fractile }

BEGIN { SortFile }
  For Row:= 1 To N DO
    Read(InPut,Data[Row]);
  QuickSort(Data,N);
  For Row:= 0 To F Do
    FracVector[Row]:= Fractile(Fracs[Row]);
END;  { SortFile }

PROCEDURE FindFractiles(var N :LongInt; FileName :String; var F :Integer;
                        var Fracs :F_Vector; Var FracVector:F_Vector);
  Var   i,j:byte;
        DummyFrac:F_Vector;

BEGIN { FindFractiles }
  Writeln('The data are being sorted');
  Assign(InPut,FileName);
    Reset(InPut);
    Moments(N,FracVector);

    Reset(InPut);
    If N<=Nmax
    Then SortFile(N,F,Fracs,FracVector)
    Else If (N mod Nmax = 0)
         Then Begin
                For i:= 0 to F Do
                  FracVector[i]:= 0;
                For j:= 1 To (N div Nmax) Do
                  Begin
                    SortFile(Nmax,F,Fracs,DummyFrac);
                    For i:= 1 to (F-1) Do
                      FracVector[i]:= FracVector[i] + DummyFrac[i];
                    If j=1 Then Begin
                                  FracVector[0]:= DummyFrac[0];
                                  FracVector[F]:= DummyFrac[F];
                                End
                           Else Begin
                                  If DummyFrac[0] < FracVector[0]
                                  Then FracVector[0]:= DummyFrac[0];
                                  If DummyFrac[F] > FracVector[F]
                                  Then FracVector[F]:= DummyFrac[F];
                                End;
                  End;
                For i:= 1 to (F-1) Do
                  FracVector[i]:= FracVector[i]/(N div Nmax);
              End
         Else For i:= 0 to F Do
                FracVector[i]:= -1;
  Close(InPut);
END;  { FindFractiles }

END.